'=========================================================================
'   ݁`pp̎d VB.NETTv
'-------------------------------------------------------------------------
'   [ComboBox]tbgR{{bNXNX
'-------------------------------------------------------------------------
'   쐬  :   2003/12/06
'   :   Visual Studio.NET 2003 / Windows XP Pro SP1
'=========================================================================
Imports System.ComponentModel

Public Class FlatComboBox : Inherits System.Windows.Forms.ComboBox

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    'UserControl ̓R|[lgꗗ邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'FlatComboBox
        '
        Me.BackColor = SystemColors.Window

    End Sub

#End Region

    Private Const WM_PAINT As Integer = &HF

    Private m_BackColor As Color = SystemColors.Window
    Private m_BorderColor As Color = SystemColors.ControlDark
    Private m_ButtonColor As Color = SystemColors.Control
    Private m_ButtonForeColor As Color = SystemColors.ControlText

    Private brBackground As New SolidBrush(MyBase.BackColor)
    Private brButton As New SolidBrush(m_ButtonColor)
    Private brButtonText As New SolidBrush(m_ButtonForeColor)
    Private brText As New SolidBrush(SystemColors.WindowText)
    Private pnBorder As New Pen(m_BorderColor)

    Private fntArrow As New Font("Marlett", 9)

    Public Overrides Property BackColor() As System.Drawing.Color
        Get
            Return MyBase.BackColor
        End Get
        Set(ByVal Value As System.Drawing.Color)
            brBackground.Dispose()
            brBackground = New SolidBrush(Value)
            MyBase.BackColor = Value
        End Set
    End Property

    Public Overrides Property ForeColor() As System.Drawing.Color
        Get
            Return MyBase.ForeColor
        End Get
        Set(ByVal Value As System.Drawing.Color)
            brText.Dispose()
            brText = New SolidBrush(Value)
            MyBase.ForeColor = Value
        End Set
    End Property

    <Browsable(True), Category("Appearance")> _
    Public Property BorderColor() As Color
        Get
            Return m_BorderColor
        End Get
        Set(ByVal Value As Color)
            m_BorderColor = Value
            pnBorder.Dispose()
            pnBorder = New Pen(m_BorderColor)
            Me.Invalidate()
        End Set
    End Property

    <Browsable(True), Category("Appearance")> _
    Public Property ButtonColor() As Color
        Get
            Return m_ButtonColor
        End Get
        Set(ByVal Value As Color)
            m_ButtonColor = Value
            brButton.Dispose()
            brButton = New SolidBrush(m_ButtonColor)
            Me.Invalidate()
        End Set
    End Property

    <Browsable(True), Category("Appearance")> _
    Public Property ButtonForeColor() As Color
        Get
            Return m_ButtonForeColor
        End Get
        Set(ByVal Value As Color)
            m_ButtonForeColor = Value
            brButtonText.Dispose()
            brButtonText = New SolidBrush(m_ButtonForeColor)
            Me.Invalidate()
        End Set
    End Property

    '-- EBhEvV[W
    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        MyBase.WndProc(m)
        If m.Msg = WM_PAINT Then

            Dim g As Graphics = Me.CreateGraphics()

            '-- ``̍쐬
            Dim rctBackground As New RectangleF(Me.ClientRectangle.Left, _
                                                Me.ClientRectangle.Top, _
                                                Me.ClientRectangle.Width - (SystemInformation.VerticalScrollBarWidth + SystemInformation.Border3DSize.Width + 1), _
                                                Me.ClientRectangle.Height - 1)
            Dim rctButton As New RectangleF(rctBackground.Left + rctBackground.Width, _
                                            rctBackground.Top, _
                                            SystemInformation.VerticalScrollBarWidth + SystemInformation.Border3DSize.Width, _
                                            rctBackground.Height)

            '-- wi̓hԂ
            g.FillRectangle(brBackground, rctBackground)
            g.FillRectangle(brButton, rctButton)

            '-- E̕`
            g.DrawRectangle(pnBorder, Rectangle.Ceiling(rctBackground))
            g.DrawRectangle(pnBorder, Rectangle.Ceiling(rctButton))

            '-- DropDownStyleDropDownList̏ꍇAeLXg`
            If Me.DropDownStyle = ComboBoxStyle.DropDownList Then
                Dim fmtText As New StringFormat
                Dim rctText As New RectangleF(rctBackground.Left + SystemInformation.Border3DSize.Width, _
                                              rctBackground.Top + SystemInformation.Border3DSize.Height, _
                                              rctBackground.Width - (SystemInformation.Border3DSize.Width * 2), _
                                              rctBackground.Height - (SystemInformation.Border3DSize.Height * 2))
                fmtText.Alignment = StringAlignment.Near
                fmtText.LineAlignment = StringAlignment.Center

                If Me.Focused And Me.DroppedDown = False Then
                    Dim brHighlight As New SolidBrush(SystemColors.Highlight)
                    Dim brHighlightText As New SolidBrush(SystemColors.HighlightText)
                    g.FillRectangle(brHighlight, rctText)
                    g.DrawString(Me.Text, Me.Font, brHighlightText, rctText, fmtText)
                    brHighlightText.Dispose()
                    brHighlight.Dispose()
                Else
                    g.DrawString(Me.Text, Me.Font, brText, rctText, fmtText)
                End If

            End If

            '-- {^̕`
            Dim fmtArrow As New StringFormat
            fmtArrow.Alignment = StringAlignment.Center
            fmtArrow.LineAlignment = StringAlignment.Center
            g.DrawString("6", fntArrow, brButtonText, rctButton, fmtArrow)

            g.Dispose()

        End If
    End Sub

    Protected Overrides Sub Finalize()
        '-- Ô߁A
        brBackground.Dispose()
        brButton.Dispose()
        brButtonText.Dispose()
        pnBorder.Dispose()
        brText.Dispose()
        fntArrow.Dispose()
        MyBase.Finalize()
    End Sub

End Class
